#include "Board.h"
#include "FKUT/Misc.h"

Board::Board(void)
{
	// [6/5]Ֆʔz̏֐
	info.initBoard();
	// Ֆʍ쐬
	setupBoard();
}

Board::~Board(void)
{
	// {͐΂̉ȂƂȂcc
}

// V[ւ̕\
void Board::entry(fk_Scene *argScene)
{
	argScene->entryModel(&blockModel);
	argScene->entryModel(&gridModel);

	return;
}

// V[̏
void Board::remove(fk_Scene *argScene)
{
	argScene->removeModel(&blockModel);
	argScene->removeModel(&gridModel);

	return;
}

// [6/19]Ֆʂ̍\z(萔Ή)
void Board::setupBoard(void)
{
	// ̂̐ݒ
	block.makeBlock(10.0 + BOARD_WIDTH*10.0, 5.0, 10.0 + BOARD_WIDTH*10.0),
	blockModel.setShape(&block);
	blockModel.setMaterial(Green);
	blockModel.glTranslate(0.0, -2.75, 0.0);

	// Obh
	fk_Vector	posA, posB;
	for(int i = 0; i < BOARD_WIDTH+1; ++i) {
		posA.set(-10.0*BOARD_WIDTH/2.0 + i*10.0, 0.0, -10.0*BOARD_WIDTH/2.0);
		posB.set(-10.0*BOARD_WIDTH/2.0 + i*10.0, 0.0,  10.0*BOARD_WIDTH/2.0);
		grid.pushLine(posA, posB);
		posA.set(-10.0*BOARD_WIDTH/2.0, 0.0, -10.0*BOARD_WIDTH/2.0 + i*10.0);
		posB.set( 10.0*BOARD_WIDTH/2.0, 0.0, -10.0*BOARD_WIDTH/2.0 + i*10.0);
		grid.pushLine(posA, posB);
	}
	gridModel.setShape(&grid);
	gridModel.setLineColor(0.0, 0.0, 0.0);
	gridModel.setWidth(2.0);

	return;
}

int Board::checkCell(const fk_Vector &argPos, fk_Vector *argAdjustPos, StoneColor argColor, bool argFlagRev)
{
	// ␳
	int tmpX = (int)argPos.x;
	int tmpZ = (int)argPos.z;
	if(tmpX > 0) {
		argAdjustPos->x = tmpX - (tmpX % 10) + 5;
	} else {
		argAdjustPos->x = tmpX - (tmpX % 10) - 5;
	}
	if(tmpZ > 0) {
		argAdjustPos->z = tmpZ - (tmpZ % 10) + 5;
	} else {
		argAdjustPos->z = tmpZ - (tmpZ % 10) - 5;
	}
	argAdjustPos->y = 0.0;

	// 3Wlz̍Wl𓾂
	CellPosition	pos = BoardInfo::calcID(*argAdjustPos);
	if(pos.x == -1) {
		return CR_OUT_RANGE;
	}

	// ɒuĂ邩`FbN
	if(info.cellInfo[pos.x][pos.y].index >= 0) {
		return info.cellInfo[pos.x][pos.y].index;
	}

	list<CellPosition>	totalRevList;
	// ЂԂ΂1ȏ゠
	if(info.checkAround(pos, argColor, argFlagRev, &totalRevList) == true) {
		// tOtrue̎ЂԂ
		if(argFlagRev == true) {
			for(ListIte ite = totalRevList.begin(); ite != totalRevList.end(); ++ite) {
				int idx = info.cellInfo[ite->x][ite->y].index;
				// ΂ɂЂԂw
				stoneArray[idx]->reverse();
				// z̏XV
				info.setStoneID(BoardInfo::calcID(stoneArray[idx]->getPosition()), idx);
			}
		}

		// uȂu邱Ƃʒm
		return CR_SUCCESS;
	}

	return CR_FAILED;
}

// œnF̐΂u󋵂ǂ𒲂ׂ
bool Board::isPuttable(StoneColor nowTurn)
{
	return info.isPuttable(nowTurn);
}

StoneColor Board::judge(int *argP_blackNum, int *argP_whiteNum) const
{
	return info.judge(argP_blackNum, argP_whiteNum);
}

// u΂ID(z̓Y)(FwȗŔ])
void BoardInfo::setStoneID(const CellPosition &argPos, int argID, StoneColor argColor)
{
	cellInfo[argPos.x][argPos.y].index = argID;
	if(argColor == ST_DEFAULT) {
		cellInfo[argPos.x][argPos.y].color = Stone::opposite(cellInfo[argPos.x][argPos.y].color);
	} else {
		cellInfo[argPos.x][argPos.y].color = argColor;
	}

	return;
}

// ΂u
int Board::makeStone(const fk_Vector &argPos, StoneColor argColor, fk_Scene *argScene)
{
	stoneArray.push_back(new Stone(argColor));
	stoneArray.back()->setPosition(argPos);
	stoneArray.back()->entry(argScene);

	// Ֆʃf[^ɉԖڂ̐΂ûZbg
	info.setStoneID(BoardInfo::calcID(argPos), stoneArray.size()-1, stoneArray.back()->getColor());

	return (int)stoneArray.size();
}

// ΂̃NA
void Board::clearStone(fk_Scene *argScene)
{
	int num = stoneArray.size();
	for(int i = 0; i < num; ++i) {
		stoneArray[i]->remove(argScene);
		delete stoneArray[i];
	}
	stoneArray.clear();
	info.initBoard();

	return;
}

// [6/19z]Z[u̎
void Board::saveState(ofstream &out_file)
{
	// ܂̓wb_sƁA΂̌o
	out_file << "[BOARD INFO]" << endl;
	int num = stoneArray.size();
	out_file << num << endl;
	// [v񂵂ĐF,x,y,z̏ɏo
	for(int i = 0; i < num; ++i) {
		fk_Vector tmpPos = stoneArray[i]->getPosition();
		out_file << stoneArray[i]->getColor() << "," << tmpPos.x << "," << tmpPos.y << "," << tmpPos.z << endl;
	}

	return;
}

// [6/19z][h̎
bool Board::loadState(ifstream &in_file, fk_Scene *argScene)
{
	string			str;
	vector<string>	strSplit;
	int				num = 0;

	// ΂̌擾
	if(getline(in_file, str)) {
		num = atoi(str.c_str());
	} else {
		return false;
	}

	// ՖʂNA
	clearStone(argScene);

	// Ԃ񃋁[vAĔzuĂ
	for(int i = 0; i < num; ++i) {
		if(getline(in_file, str)) {
			// J}؂ŕ
			strSplit = fk_StrSplit(str, ",");
			// ڂ4ȏȂ珈AłȂ΃G[
			if(strSplit.size() >= 4) {
				// 3ZqŐF̒萔
				StoneColor	color = (atoi(strSplit[0].c_str()) == 0) ? ST_BLACK : ST_WHITE;
				// ʒuWfk_Vectorɕ
				fk_Vector	pos(atof(strSplit[1].c_str()), atof(strSplit[2].c_str()), atof(strSplit[3].c_str()));
				// ΂̔zu(Q[vCƓ֐g񂷂̂|Cg)
				makeStone(pos, color, argScene);
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	return true;
}

// [6/19z]
void Board::update(StoneColor argNowTurn)
{
	// [6/5]]Aj[V̂߁ASĂ̐΂̏Ԃ𖈃t[XV
	int num = stoneArray.size();
	for(int i = 0; i < num; ++i) {
		stoneArray[i]->update(argNowTurn);
	}
}

bool Board::isAnimate(void)
{
	int num = stoneArray.size();
	for(int i = 0; i < num; ++i) {
		if(stoneArray[i]->isSpin()) return true;
	}
	return false;
}

BoardInfo& Board::getInfo(void)
{
	return info;
};
