#ifndef __BOARDINFO_H__
#define __BOARDINFO_H__

#include <FK/FK.h>
#include "Stone.h"


// [6/19]Ֆʂ̃TCYォς悤ɒ萔
const int BOARD_WIDTH = 8;

// [6/19]2zł̍Wld\
struct CellPosition {
	int	x, y;

	// RXgN^(-1ŏ)
	CellPosition(int x = -1, int y = -1)
	{
		this->x = x, this->y = y;
	};

	// Ֆʂ̒ɍWl܂Ă邩𒲂ׂ֐
	bool isValid(void) const
	{
		if(x >= 0 && x < BOARD_WIDTH && y >= 0 && y < BOARD_WIDTH) return true;
		
		return false;
	};

	// ŖpFZqĒ`(Iy[^I[o[[h)
	friend CellPosition operator(const CellPosition &l, const CellPosition &r)
	{
		return (l.x == r.x && l.y == r.y);
	};
	friend CellPosition operator+(const CellPosition &l, const CellPosition &r)
	{
		return CellPosition(l.x + r.x, l.y + r.y);
	};
};

// [6/19]2zŎ΂̗vfԍƐFɊg
struct CellData {
	int			index;	// ̃ZɒuĂ΂̗vfԍ
	StoneColor	color;	// ̃Z̒uĂF
};

class BoardInfo {
public:
	friend class Board;

	BoardInfo(void);
	virtual ~BoardInfo(void);
	// ŖpFZqĒ`(Iy[^I[o[[h)2nd
	BoardInfo operator=(const BoardInfo &argOP);

	// Ֆʃf[^
	void	initBoard(void);

	// uꏊ̃Xg𓾂֐
	bool	getPuttableList(StoneColor nowTurn, list<CellPosition> *putList) const;

	// ۂɒuĂ݂ĂǂȂ邩m߂֐
	bool	putTest(StoneColor color, const CellPosition &pos);
	
	// w肵Wl̐F𓾂֐
	StoneColor	getColor(const CellPosition &pos);

	// s֐
	StoneColor	judge(int *blackNum, int *whiteNum) const;

	// 3Wlz̍Wlɕϊ(萔Ή)
	static CellPosition	calcID(const fk_Vector &pos);
	// z̍Wl3Wlɕϊ
	static fk_Vector	calcPos(const CellPosition &pos);

protected:
	// Ֆʏ̃f[^2zŎ
	CellData		cellInfo[BOARD_WIDTH][BOARD_WIDTH];

	// u΂ID(z̓Y)(FwȗŔ])
	void	setStoneID(const CellPosition &pos, int id,
						StoneColor color = ST_DEFAULT);
	// ̐΂ӂɂ邩𒲂ׂ֐
	bool	checkAround(const CellPosition &pos, StoneColor color,
						bool flagRev, list<CellPosition> *revList) const;
	// u邩ǂ𔻒肷֐
	bool	isPuttable(StoneColor nowTurn) const;
};

#endif //__BOARDINFO_H__
